// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on
real vector function m_mvport(string scalar varlist, real scalar ret, real matrix vecweights, string scalar touse, string scalar casewis, real matrix covmatrix, real matrix mrets, real matrix vecmaxweights, real scalar noshort)
{
real matrix r, covmat, COV, MR, WT, riskdecomposition
real scalar sigue, retp, riskp, varp, j, i, maxwei, coltodelete, rettemp, extraweight
real vector vecw, vecmaxw
real vector W, WI, Wdif, Wdifsort, Wind, WN, WF

st_view(r=.,.,tokens(varlist), touse)
sigue=1
maxwei=1

if (cols(covmatrix)<=1) {
 COV=m_expvar(r,-1,WT,casewis,J(1,1,1))
 }
else {
  COV=covmatrix
}  
covmat=COV
if (rows(mrets)<=1) {
  MR=m_exprets(r, casewis)
}
else {
  MR=mrets
} 
mrets=MR

vecw=vecweights[.,1]
vecmaxw=vecmaxweights[.,1]
Wind=J(cols(r),1,.)
Wind=range(1,cols(r),1)
i=0
rettemp=ret
while (sigue & cols(covmat)>1) {
  i++
  if (noshort==1) { 
   W = m_mvportwos2(rettemp,vecw,covmat,mrets)
  }
  else {
   W = m_mvportws(rettemp,covmat,mrets)
  } 
  if (i>1) {
    WF=WF + extraweight*W
 }
  else {
    WF=W
  }
  Wdif=vecmaxw - WF  
  Wdifsort=order(Wdif,1)
  coltodelete=Wdifsort[1]
  sigue = (Wdif[coltodelete] < 0 ? 1: 0)
  if (sigue) {
     extraweight=-1*Wdif[coltodelete]
	 maxwei=maxwei - vecmaxw[coltodelete]
	 covmat=m_dropcolren(covmat,coltodelete)
     mrets=m_dropren(mrets,coltodelete) 
	 vecw=m_dropren(vecw,coltodelete)
	 vecmaxw=m_dropren(vecmaxw,coltodelete) 
	 Wind=m_dropren(Wind,coltodelete)
	 WF=m_dropren(WF,coltodelete)
  
   WN = vecmaxweights
   for (j=1; j<=rows(Wind); j++) {
     WN[Wind[j]]=0
   }
  rettemp = (ret - quadcross(WN,MR)) / (1- colsum(WN))	
 } 
} 

WI=vecmaxweights[.,1]
for (j=1; j<=rows(Wind); j++) {
   WI[Wind[j]]=WF[j]
}
W=WI

retp=quadcross(W,MR)
varp=quadcross(W,COV)*W
riskp=sqrt(varp)
riskdecomposition= COV*W :/ riskp
st_matrix("r(weights)",W)
st_matrix("r(cov)",COV)
st_matrix("r(exprets)",MR)
st_matrix("r(rdecomposition)",riskdecomposition)
st_numscalar("r(retp)",retp)
st_numscalar("r(varp)",varp)
st_numscalar("r(sdp)",riskp)
st_numscalar("r(N)",rows(r))
return(W)
}
end
mata: mata mosave m_mvport(), dir(PERSONAL) replace
