// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on

real vector function m_ovportwos2(real matrix vecweights, real scalar nport, real scalar rfrate, real matrix covmatrix, real matrix mrets)
{
real matrix COV, MR, wefwos, refwos, sdefwos, vsharpe, vsharpe_order
real vector gmvp, pmv, wop
real scalar j, rgmvp, delta, Ri, i
  MR=mrets
  COV=covmatrix
  wefwos=J(nport,rows(MR),.)
  refwos=J(nport,1,.)
  sdefwos=J(nport,1,.)
  vsharpe=J(nport,1,.)
  gmvp = m_gmvportwos2(vecweights, covmatrix)
  rgmvp = quadcross(gmvp,MR)
  Ri=rgmvp
  delta=(max(MR) - rgmvp) / (nport-1) 
  for (j=1; j<=nport; j++) {
    pmv = m_mvportwos2(Ri, vecweights, covmatrix, mrets)
	refwos[j,1]=quadcross(pmv,MR)	
    sdefwos[j,1]=sqrt(quadcross(pmv,COV)*pmv)
    wefwos[j,.] = pmv'[.]  
   vsharpe[j,1]=(refwos[j,1] - rfrate) / sdefwos[j,1]
   Ri=Ri+delta
  }
     vsharpe_order=order(vsharpe,1)
	 i=cols(wefwos)
	 wop=wefwos[vsharpe_order[nport,1],1..i]
	 return(wop')
}
end
mata: mata mosave m_ovportwos2(), dir(PERSONAL) replace
